<template>
  <main>
    <mt-page-title
      :link-to="profilLink({ name: 'activites-id', params: { id: activite.id }, query: { visu: visu } })"
      link-text="Retour à l'activité"
    >
      <h1 class="has-text-weight-bold is-size-3">Duplication d'une activité</h1>
    </mt-page-title>
    <form @submit.prevent="submit">
      <mt-form-fields-activity
        :activite="activite"
        :effectif-previsionnel="effectifPrevisionnel"
        :pax-max="nombrePax"
        @majEffectifPrevisionnel="majEffectifPrevisionnel"
      />
      <footer class="columns is-vcentered mt-margin-top is-centered ">
        <div class="column is-narrow-desktop">
          <nuxt-link :to="{ name: 'index' }">
            <b-button class="mt-button has-text-weight-semibold is-size-8" type="is-secondary" expanded>
              annuler
            </b-button>
          </nuxt-link>
        </div>
        <div class="column is-narrow-desktop">
          <b-button
            class="mt-button has-text-weight-semibold is-size-8 has-text-weight-semibold"
            type="is-primary"
            native-type="submit"
            expanded
          >
            Créer l’activité
          </b-button>
        </div>
      </footer>
    </form>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtFormFieldsActivity from '~/components/activity/form-fields-activity';
import { creationActivite, newActivity } from '~/components/mixins/activityMixin';

export default {
  layout: 'container-small',
  components: {
    MtPageTitle,
    MtFormFieldsActivity,
  },
  mixins: [creationActivite],
  async asyncData(context) {
    const activite = Object.assign(newActivity(context.store), await context.$api.activites.get(context.params.id));
    if (context.query['start-date'] && context.query['end-date']) {
      activite.dateDebut = new Date(context.query['start-date']);
      activite.dateFin = new Date(context.query['end-date']);
    }
    const [nombrePax, effectifPrevisionnel] = await Promise.all([
      context.$api.activites.nombreDePax(activite.organisme.id),
      context.$api.organisme().disponibilitesComplete(activite.dateDebut.toISOString(), activite.dateFin.toISOString()),
    ]);
    const visu = context.query && context.query.visu ? context.query.visu : null;
    return {
      effectifPrevisionnel,
      activite,
      nombrePax,
      visu,
    };
  },
};
</script>

<style scoped lang="scss"></style>
